#!/usr/bin/perl -w
# $Id$

use strict;

use Test::More ( tests => 8 );


use POE::Component::IKC::Freezer qw(freeze thaw dclone);

pass( 'loaded' );


my $data={foo=>"bar", biff=>[qw(hello world)]};

my $str=freeze($data);
ok( $str, "Froze some data" );

my $data2=thaw($str);
ok( $data2, "Thawed some data" );
is_deeply( $data, $data2, "Thawed the same data" );


$data2=dclone($data);
is_deeply( $data, $data2, "Cloned that data" );


$data->{biffle}=$data->{biff};
$data2=dclone($data);
is( $data2->{biffle}, $data2->{biff}, "References survived" );
is_deeply( $data, $data2, "And everything is the same" );


# circular reference
$data->{flap}=$data->{biffle};
push @{$data->{biffle}}, $data->{flap};
$data2=dclone($data);

is( $data->{biffle}[-1], $data->{biffle}, "Circular references survived" );


